////////////////////////IMPORTANT/////////////////////////////////////////
//Initialise all variables explicitly in all functions i.e 				//
//Initialising the variables while declaring the variables is not enough//
//They have 2 b explicitly set 2 0 or memset							//
//////////////////////////////////////////////////////////////////////////


//Do not ASSIGN INTEGER VALUES TO CHARACTERS

#include <REG51F.H> 
#include <absacc.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <intrins.h>
   

//Serial config used only in Init
code void serial_config();
code void pause(unsigned int); // delay subroutine
code void Transmit(char);
code void WRITERAMTEST(int);
code void CLRRAMTEST();
code void READRAMTEST();
code void TransmitLine();
code void TransmitAddress(char cAdd);
code void TransmitString(char *str);
code void CLRRAMTEST2();

volatile int PSHnIndex=0;
volatile int POPnIndex=0;
volatile char data inputBuffer[40]={'\0'}; 
volatile int PSH=0;
volatile int POP=0;
volatile unsigned int delay = 0;
volatile char indata ='\0';
volatile char cData='\0';
volatile char  idata cInputData[40]={'\0'};
volatile long unsigned int i=0;
volatile long unsigned int idata j=0;  

volatile unsigned char xdata cUserName[31]		_at_ 0xD422;
volatile unsigned char xdata cPassword[31] 		_at_ 0xD4B3;

volatile  unsigned int nH=0;
volatile  unsigned int nV=0;
volatile  unsigned int nD=0;
volatile  unsigned int idata bFlag=0;
volatile  unsigned int nComma[20];
volatile char idata cTemp[20];
volatile long unsigned int idata iA=0;	
volatile char idata chA='\0';

void main()
{
	//Initializing parameters for Serial communication
	serial_config();
	PSHnIndex=0;
	PSH=0;
	memset(cInputData,'\0',sizeof(cInputData));
	memset(inputBuffer,'\0',sizeof(inputBuffer));
	TransmitString("DIAGNOSTIC TOOL STARTED\r\n");
	bFlag =0;

//bFlag1 = 0;
	while(1)
	{
		//Test Procedure to indicate 
		//74HCT574, 7432 & 74HCt245(U1) is working
	

		CLRRAMTEST2();
		PSH=0;
		

			
					WRITERAMTEST(0);
					WRITERAMTEST(1);
					WRITERAMTEST(2);
				PSH=0;
				TransmitString("CMD:OK\r\n");

			CLRRAMTEST();
			TransmitString("CMD:OK\r\n");
		
			READRAMTEST();
			TransmitString("CMD:OK\r\n");	

	}//while
}//main


//Initializing parameters 4 serial communication
void serial_config()
{
	//CKCON Register is available only in 89C61X2BN
	//If 89C51RD2 is used comment this line
	//CKCON= 0x01;	//Setting to 6 Clock mode for 89C61X2BN

	//Timer Setting //0010 0000 Mode 2 Timer1
	TMOD = 0x20;    
	//To set the baud rate-4800-Timer1
	TH1 = 0xF4;     
	//Serial Port Control Register 10 bits - 1 start bit, 8 data bits,1 Stop bit
	//Enables Serial reception
	SCON = 0x50;	//0101 0000 Serial Mode1 ,REN Enabled
	//Start timer1
	TR1 = 1;

	//Serial Port interrupt enable bit. & Global Enable bit
	IE |= 0x90;		//1001 0000 Enables the Serial Port Interrupt
	//External interrupt 0 enable bit.
	EX0=1;
	//Global Enable bit,//Interrupts are enabled and will be responded to if their corresponding bits in IE are high
	EA = 1;			
}


void serial_ISR(void) interrupt 4 using 1 
{
	volatile char cData='\0';
	if (RI) 
	{     
		//Should not do any arithmetic operations along with SBUF
		cData=SBUF;
		RI=0;
		cData=cData & 0x7F;
		cInputData[PSH]=cData;
		PSH++;
		if((cData =='\r')||(cData == '\n')||(PSH >=98))
		{
			memset(cInputData,'\0',sizeof(cInputData));
			PSH=0;
		}

	}
}

void TransmitString(char *str)
{
	volatile char cnt=0;
	volatile char len=0;
	len=strlen(str);
	for(cnt=0;cnt<len;cnt++)
	{
		Transmit(str[cnt]);
	}
}


void Transmit(char cS)
{
	SBUF = cS;	
	while(!TI);
	     TI=0;
	
}

void CLRRAMTEST()
{
	for(i=0x0000;i<=0xEFFF;i++)
	{
		XBYTE[i]='\0';
	
	}
}

void READRAMTEST()
{
	volatile char ch;

	//Reading Block 0x0000 to 0x0FFF
	TransmitLine();
	TransmitAddress('1');
	for(i=0x1000;i<=0x1FFF;i++)
	{
		ch=XBYTE[i];
        _nop_();
		Transmit(ch);
		if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
        _nop_();
		_nop_();
        
	}

	//Reading Block 0x1000 to 0x1FFF
	TransmitLine();
	TransmitAddress('0');
	for(i=0x0000;i<=0x0FFF;i++)
	{
		ch=XBYTE[i];
       if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
		Transmit(ch);
        _nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
	}
	
	//Reading Block 0x2000 to 0x2FFF
	TransmitLine();
	TransmitAddress('2');	
	for(i=0x2000;i<=0x2FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0x3000 to 0x3FFF
	TransmitLine();
	TransmitAddress('3');
	for(i=0x3000;i<=0x3FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
			_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0x4000 to 0x4FFF
	TransmitLine();
    TransmitAddress('4');
	for(i=0x4000;i<=0x4FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}
	
	//Reading Block 0x5000 to 0x5FFF
	TransmitLine();
	TransmitAddress('5');
	for(i=0x5000;i<=0x5FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0x6000 to 0x6FFF
	TransmitLine();
	TransmitAddress('6');
	for(i=0x6000;i<=0x6FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}
	

	//Reading Block 0x7000 to 0x7FFF
	TransmitLine();
	TransmitAddress('7');
	for(i=0x7000;i<=0x7FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0x8000 to 0x8FFF
	TransmitLine();
	TransmitAddress('8');
	for(i=0x8000;i<=0x8FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
			 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0x9000 to 0x9FFF
	TransmitLine();
	TransmitAddress('9');
	for(i=0x9000;i<=0x9FFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
			 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0xA000 to 0xAFFF
	TransmitLine();
	TransmitAddress('A');
	for(i=0xA000;i<=0xAFFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0xB000 to 0xBFFF
	TransmitLine();
	TransmitAddress('B');
	for(i=0xB000;i<=0xBFFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
			 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0xC000 to 0xCFFF
	TransmitLine();
	TransmitAddress('C');
	for(i=0xC000;i<=0xCFFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0xD000 to 0xDFFF
	TransmitLine();
	TransmitAddress('D');
	for(i=0xD000;i<=0xDFFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		_nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}

	//Reading Block 0xE000 to 0xEFFF
	TransmitLine();
	TransmitAddress('E');
	for(i=0xE000;i<=0xEFFF;i++)
	{
		ch=XBYTE[i];
		Transmit(ch);
		    _nop_();
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		 if((i%50)==0)
		{
			Transmit('\r');
         	Transmit('\n');
		}
	}
	TransmitLine();

	Transmit(0x1A);
	//pause(500);
}


void TransmitLine()
{
	volatile  int ij=0;
	Transmit('\r');
	Transmit('\n');
	for(ij=0;ij<40;ij++)
	{
		Transmit('-');
	}
	Transmit('\r');
	Transmit('\n');
}

void TransmitAddress(char cAdd)
{
	Transmit('0');
	Transmit('X');
	Transmit(cAdd);
	Transmit('0');
	Transmit('0');
	Transmit('0');
	Transmit('-');
	Transmit('-');
	Transmit('0');
	Transmit('X');
	Transmit(cAdd);
	Transmit('F');
	Transmit('F');
	Transmit('F');
	TransmitLine();
}




